///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//  Copyright  NetworkDLS 2002, All rights reserved
//
// THIS CODE AND INFORMATION IS PROVIDED "AS IS" WITHOUT WARRANTY OF 
// ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO 
// THE IMPLIED WARRANTIES OF MERCHANTABILITY AND/OR FITNESS FOR A 
// PARTICULAR PURPOSE.
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

#ifndef _CIntegerStack_H
#define _CIntegerStack_H
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

class CIntegerStack{

	public:
		bool Init(unsigned int iInitialSize, bool bAutoGrow);
		bool Init(void);
		bool Destroy(void);
		unsigned int GetStackSize(void);
		unsigned int GetFreeSize(void);
		unsigned int GetStackLevel(void);
		bool IsStackEmpty(void);
		bool IsStackFull(void);

		bool Push(int iNumber);
		bool Pop(int *iNumber);
		int Pop(void);

		bool Peek(int *iNumber);
		bool Peek(unsigned int iSlot, int *iNumber);

	private:
		unsigned int iStackSize;
		unsigned int iInitialSize;

		int *iStack;
		unsigned int iFree;
		bool bAutoGrow;
};

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
#endif
